---
title: Forgejo Security Release 1.18.2-1
publishDate: 2023-01-23
tags: ['releases', 'security']
release: 1.18.2-1
excerpt: Forgejo v1.18.2-1 stable release update fixes a bug that made it possible to reveal hidden user email addresses.
---

Today [Forgejo v1.18.2-1](https://codeberg.org/forgejo/forgejo/releases/tag/v1.18.2-1) was released.

This stable release **includes a security fix**. It was possible to reveal a user's email address, which is problematic because users can choose to hide their email address from everyone. This was possible because the notification email for a repository transfer request to an organization included every user's email address in the owner team. This has been fixed by sending individual emails instead and the code was refactored to prevent it from happening again.

### Recommended Action

We **strongly recommend** that all installations are upgraded to the latest version as soon as possible.

### Forgejo installation instructions

See the [download page](/download)
for instructions for installation instructions. If you are upgrading from `Forgejo 1.18.X-N` (or `Gitea 1.18`) no manual action is required. If you're on `Gitea v1.17.X` or older please read the [release notes](https://codeberg.org/forgejo/forgejo/src/branch/forgejo/RELEASE-NOTES.md#1-18-0-1)
carefully, and in particular check out the [breaking changes](https://blog.gitea.io/2022/12/gitea-1.18.0-is-released/#breaking-changes) section of Gitea's blog post.

The actual upgrade process is as simple as replacing the Gitea binary or container image
with the corresponding [Forgejo binary](https://codeberg.org/forgejo/forgejo/releases/tag/v1.18.2-1)
or [container image](https://codeberg.org/forgejo/-/packages/container/forgejo/1.18.2-1).
If you're using the container images, you can use the
[`1.18`](https://codeberg.org/forgejo/-/packages/container/forgejo/1.18) tag
to stay up to date with the latest `1.18.x` point release automatically.

### Codeberg is not vulnerable

The [Forgejo security team](/.well-known/security.txt) is a joint effort with [Codeberg](https://codeberg.org) which already runs a Forgejo version that includes the security fix.

### Responsible disclosure to Gitea

On 21 January 2023, as soon as the [Forgejo security team](/.well-known/security.txt) confirmed the vulnerability, the detailed conclusions were communicated to the Gitea security team. The corresponding bug fix was published [22 January 2023](https://github.com/go-gitea/gitea/pull/22569).

### Contribute to Forgejo

If you have any feedback or suggestions for Forgejo, we'd love to hear from you!
Open an issue on [our issue tracker](https://codeberg.org/forgejo/forgejo/issues)
for feature requests or bug reports. You can also find us [on the Fediverse](https://floss.social/@forgejo),
or drop by [our Matrix space](https://matrix.to/#/#forgejo:matrix.org)
([main chat room](https://matrix.to/#/#forgejo-chat:matrix.org)) to say hi!
