---
title: Forgejo Security Release 1.21.2-1
publishDate: 2023-12-12
tags: ['releases', 'security']
release: 1.21.2-1
excerpt: The Forgejo v1.21.2-1 release contains an additional security fix related to permissions enforcement of API endpoints.
---

[Forgejo v1.21.2-1](https://codeberg.org/forgejo/forgejo/releases/tag/v1.21.2-1) was released 12 December 2023.

This release contains _a security fix_ related to permissions enforcement of web endpoints.

### Recommended Action

We _strongly recommend_ that all Forgejo installations are upgraded to the latest version as soon as possible.

### The project page of private users is publicly visible

The [project page](https://forgejo.org/docs/v1.21/user/project/) of a
private user was missing a permission check and was visible
publicly. The other pages (packages, repositories, etc.) of this user
or even its existence are not visible publicly.

### Reminder of responsible disclosure

On 11 December 2023 the project page vulnerability was [revealed publicly](https://github.com/go-gitea/gitea/pull/28423)
in contradiction with the
[Gitea](https://github.com/go-gitea/gitea/blob/763938e889c233e82a1a046010b9d332abaa833f/SECURITY.md#reporting-a-vulnerability) and
[Forgejo](https://codeberg.org/forgejo/forgejo/src/branch/forgejo/CONTRIBUTING.md) security policies
as well as the [general principles of responsible disclosure](https://en.wikipedia.org/wiki/Coordinated_vulnerability_disclosure).

This unfortunate incident forced the immediate preparation of this
Forgejo patch release. With no advance warning it only allowed for limited testing
and there is a non negligible risk of a regression.

In such a situation the Forgejo admins and users are suffering the
consequences, either because they are left unnecessarily exposed to
publicly known vulnerabilities or because their instance may run into
regressions due to insufficient preparation time and testing.

If you discover a new vulnerability, you are **urged to not reveal it
publicly** but to [send an encrypted email](https://forgejo.org/.well-known/security.txt) to security@forgejo.org so
this situation does not happen again.

### Contribute to Forgejo

If you have any feedback or suggestions for Forgejo, we'd love to hear from you! Open an issue on [our issue tracker](https://codeberg.org/forgejo/forgejo/issues) for feature requests or bug reports. You can also find us [on the Fediverse](https://floss.social/@forgejo), or drop by [our Matrix space](https://matrix.to/#/#forgejo:matrix.org) ([main chat room](https://matrix.to/#/#forgejo-chat:matrix.org)) to say hi!
