---
title: Forgejo is now copyleft, just like Git
publishDate: 2024-08-22
tags: ['news']
excerpt: In June 2023, Forgejo agreed to allow copyleft code to be merged in the codebase. A year later, in August 2024, the first pull requests to take advantage of this opportunity were merged. Forgejo versions starting from v9.0 are now released under a copyleft license and earlier Forgejo versions, including v8.0 and v7.0 patch releases remain under the MIT license.
---

Forgejo is changing its license to a [Copyleft license](https://en.wikipedia.org/wiki/Copyleft). This blog post will try to bring clarity about the impact to you, explain the motivation behind this change and answer some questions you might have.

## How will this impact me?

We have carefully considered the impact the license change has on the variety of usages of Forgejo, and we believe there is little reason to worry. We are not aware of any negative consequences implied by the license change to users who are aligned with Forgejo's values. While we cannot give legal advice of any kind, we'll give a first overview of the new requirements.

If you set up Forgejo from our official distributions
(e.g. binaries, docker images etc),
it is very unlikely that you are affected at all.
We do our best to ensure that our Forgejo distributions are fully compliant out of the box.

You can also build Forgejo from source, even modify it,
host it for yourself and others.

If you are redistributing Forgejo binaries,
for example because you are packaging it for GNU/Linux distributions
or some specific container / package format,
you are now required to provide the full source of your Forgejo variant
(including potential modifications)
under the same license terms as Forgejo itself.

You are free to sell Forgejo services,
including hosting it for others.
If you act according to our values and ensure your users receive the freedoms Forgejo grants you,
it is unlikely that you have to do adjustments to your business now or in the future.

You might have chosen to avoid copyleft software,
for example because it is discouraged in your company.
However, Forgejo depends on Git, one of the most successful copyleft software.
Both Forgejo and Git must be used together, either as individual binaries or bundled into the [official container images](https://codeberg.org/forgejo-experimental/-/packages/container/forgejo/v9.0-test). The license of Git is [GNU GPL v2](https://git-scm.com/about/free-and-open-source), another version of the same [copyleft license](https://www.gnu.org/licenses/copyleft.html).

## Why the license change?

Developers who choose to publish their work under a copyleft license are excluded from participating in software that is published under a permissive license. That is at the opposite of the [core values](https://codeberg.org/forgejo/governance/src/branch/main/MISSION.md#values) of the Forgejo project and [in June 2023 it was decided to also accept copylefted](https://codeberg.org/forgejo/governance/pulls/20) contributions.
A year later, in August 2024, the first pull request [to take advantage of this opportunity](https://codeberg.org/forgejo/governance/src/branch/main/AGREEMENTS.md#licensing) was [proposed and merged](https://codeberg.org/forgejo/forgejo/pulls/4698/files).

A copyleft license makes reusing other copyleft software easier.
Recently, we discovered that
[some of the dependencies we used were incompatible with the license Forgejo was distributed with](https://forgejo.org/2024-07-non-free-dependency-found/),
and they had to be removed for now.
Choosing copyleft licenses enables us to reuse more work,
and saves us precious time to focus on improving Forgejo itself.

Copyleft licenses do not only benefit the developers.
They also guarantee freedoms to users of the software.
They reduce the risk of exploitive business practices,
like creating a modified version of Forgejo with less freedoms to the users,
which could ultimately trap users in a vendor lock-in.

## What is changing, now and in the future?

Forgejo versions starting from v9.0 are now released [under the GPL v3+](https://codeberg.org/forgejo/forgejo/src/branch/forgejo/LICENSE) and earlier Forgejo versions, including v8.0 and v7.0 patch releases remain under [the MIT license](https://codeberg.org/forgejo/forgejo/src/branch/v8.0/forgejo/LICENSE).

The license of Forgejo is not carved in stone and this change shows that it can adapt to the needs of the project. It also shows that it is a long process: it took months of discussions to reach the agreement in 2023. And another year for it to be put to use. This slow pace reflects how difficult it is to make a sound decision knowing it will have a long lasting impact.

The [discussions on how to improve](https://codeberg.org/forgejo/discussions/issues/192) Forgejo's licensing are still very lively and will eventually lead to decisions that will improve its legal protection, in the interest of the general public.

## Contribute to Forgejo

Forgejo is in a unique position among the software forges:
It serves its users and is guaranteed to be free and independent,
managed by a non-profit organization and [a transparent governance process](https://codeberg.org/forgejo/governance).

If you are considering contributing to Forgejo,
now that your work is protected by a copyleft license,
we welcome you to our exciting journey and we are looking forward to forging with you.

If you want to back Forgejo's independence with a financial contribution,
check out our newly-created [Liberapay team](https://liberapay.com/forgejo)
to compensate our developers for their invested time.

If you have any feedback or suggestions, do not hold back, it is also your project.
Open an issue in [the issue tracker](https://codeberg.org/forgejo/forgejo/issues)
for feature requests or bug reports, reach out [on the Fediverse](https://floss.social/@forgejo),
or drop into [the Matrix space](https://matrix.to/#/#forgejo:matrix.org)
([main chat room](https://matrix.to/#/#forgejo-chat:matrix.org)) and say hi!
